//Things for Aircore Station Zone.

local function SetGhostTrail(line, mobj)
	P_SpawnGhostMobj(mobj)
end
addHook("LinedefExecute", SetGhostTrail, "SETGHOST")

local function OrangeLaser(line, mo)
	if (mo.player.speed == 0*FRACUNIT)
	and not (mo.player.pflags & PF_JUMPED)
	P_DamageMobj(mo)
	end
end
addHook("LinedefExecute", OrangeLaser, "ORNGLSR")

local function BlueLaser(line, mo)
	if (mo.player.speed > 0*FRACUNIT)
	or (mo.player.pflags & PF_JUMPED)
	P_DamageMobj(mo)
	end
end
addHook("LinedefExecute", BlueLaser, "BLUELSR")

//Egg Zap!

freeslot("sfx_eggyel", "S_LB_OPEN1", "S_LB_DEATH4", "S_LB_ZAP11", "S_LB_RAGEZAP1", "sfx_eggrg1", "sfx_eggrg2", "sfx_eggrg3", "sfx_egglg1", "sfx_egglg2", "sfx_egglg3", "sfx_egglg4", "sfx_egglg5", "sfx_eggtn1", "sfx_eggtn2", "sfx_eggtn3", "sfx_eggtn4", "MT_EGGZAP", "S_LB_RAGE1", "S_LB_PAIN1", "S_LB_TRIPLEZAPNUM1", "S_LB_TRIPLEZAPNUM2", "S_LB_TRIPLEZAPNUM3", "S_LB_TRIPLEZAPNUM4", "S_LB_FORCECLOSE1", "S_LB_ZAP3", "S_LB_RAGEZAP3", "S_LB_ZAPNUM1", "S_LB_ZAPNUM2", "S_LB_ZAPNUM3", "S_LB_ZAPNUM4", "S_LB_ZAPNUM5", "S_LB_ZAPNUM6", "S_LB_SSZAPNUM1", "S_LB_SSZAPNUM2", "S_LB_SSZAPNUM3", "S_LB_SSZAPNUM4", "S_LB_SSZAPNUM5", "S_LB_SSZAPNUM6", "S_LB_SZAPNUM1", "S_LB_SZAPNUM2")

addHook("MobjThinker", function(boss)
 for player in players.iterate
  if (boss.state == S_LB_PAIN1)
  local chance = {1, 2, 3}
			chance = chance[P_RandomKey(#chance)+1]
		if chance == 1
		S_StartSound(boss, sfx_eggrg1)
		elseif chance == 2
		S_StartSound(boss, sfx_eggrg2)
		elseif chance == 3
		S_StartSound(boss, sfx_eggrg3)
		end
  end
 end
end, MT_EGGZAP)

addHook("MobjThinker", function(boss)
 for player in players.iterate
  if (boss.state == S_LB_PAIN1) or (boss.state == S_LB_FORCECLOSE1) or (boss.state == S_LB_DEATH1)
  P_TeleportMove(player.mo, 0*FRACUNIT, 480*FRACUNIT, 5*FRACUNIT)
  P_FlashPal(player, PAL_WHITE, 11)
  S_StartSound(nil, sfx_mixup)
  player.powers[pw_nocontrol] = 20
  player.mo.momx = 0
  player.mo.momy = 0
  player.mo.momz = 0
  end
 end
end, MT_EGGZAP)

addHook("MobjThinker", function(boss)
 for player in players.iterate
  if (boss.state == S_LB_DEATH4) or (boss.state == S_LB_DEATH5)
  boss.momz = $1 + 4*FRACUNIT
  end
 end
end, MT_EGGZAP)

addHook("MobjThinker", function(boss)
  if (boss.state == S_LB_ZAP11) or (boss.state == S_LB_RAGEZAP1)
  local chance = {1, 2, 3, 4, 5, 6, 7, 8, 9}
			chance = chance[P_RandomKey(#chance)+1]
		if chance == 1
		S_StartSound(boss, sfx_egglg1)
		elseif chance == 2
		S_StartSound(boss, sfx_egglg2)
		elseif chance == 3
		S_StartSound(boss, sfx_egglg3)
		elseif chance == 4
		S_StartSound(boss, sfx_egglg4)
		elseif chance == 5
		S_StartSound(boss, sfx_egglg5)
		elseif chance == 6
		S_StartSound(boss, sfx_eggtn1)
		elseif chance == 7
		S_StartSound(boss, sfx_eggtn2)
		elseif chance == 8
		S_StartSound(boss, sfx_eggtn3)
		elseif chance == 9
		S_StartSound(boss, sfx_eggtn4)
		end
  end
end, MT_EGGZAP)

addHook("MobjThinker", function(boss)
  if (boss.state == S_LB_DEATH4)
		S_StartSound(nil, sfx_eggyel)
  end
end, MT_EGGZAP)

addHook("MobjThinker", function(boss)
  if leveltime == TICRATE/3
		S_StartSound(boss, sfx_alarm)
  end
end, MT_EGGZAP)

addHook("MobjThinker", function(boss)
  if leveltime == 2*TICRATE/3
		S_StartSound(boss, sfx_alarm)
  end
end, MT_EGGZAP)

addHook("MobjThinker", function(boss)
  if leveltime == 1*TICRATE
		S_StartSound(boss, sfx_alarm)
  end
end, MT_EGGZAP)

addHook("MobjThinker", function(boss)
  if leveltime == TICRATE/3+1*TICRATE
		S_StartSound(boss, sfx_alarm)
  end
end, MT_EGGZAP)

addHook("MobjThinker", function(boss)
  if leveltime == 2*TICRATE/3+1*TICRATE
		S_StartSound(boss, sfx_alarm)
  end
end, MT_EGGZAP)

addHook("MobjThinker", function(boss)
  if boss.valid
  and boss.explode == nil
  boss.explode = 0
  end
  if boss.valid
  and boss.animation == nil
  boss.animation = 0
  end
  if boss.valid
  and boss.health <= 5
  and boss.health > 0
  boss.explode = $1 + 1
  end
  if boss.valid
  if boss.state == S_LB_OPEN1
  boss.animation = $1 + 1
  else
  boss.animation = 0
  end
  end
  if boss.animation >= 10
  boss.animation = 0
  end
  if boss.animation <= 10
  and boss.animation >= 5
  and boss.state == S_LB_OPEN1
  boss.frame = A
  end
  if boss.animation < 5
  and boss.animation >= 0
  and boss.state == S_LB_OPEN1
  boss.frame = A
  end
  if boss.explode >= 20
  boss.explode = 0
  end
  if boss.explode == 10
  and boss.health > 0
  A_BossScream(boss)
  end
  if boss.state == S_LB_ZAP3
  local chance = {1, 2, 3, 4, 5, 6}
			chance = chance[P_RandomKey(#chance)+1]
		if chance == 1
		boss.state = S_LB_ZAPNUM1
		elseif chance == 2
		boss.state = S_LB_ZAPNUM2
		elseif chance == 3
		boss.state = S_LB_ZAPNUM3
		elseif chance == 4
		boss.state = S_LB_ZAPNUM4
		elseif chance == 5
		boss.state = S_LB_ZAPNUM5
		elseif chance == 6
		boss.state = S_LB_ZAPNUM6
		end
  end
  if boss.state == S_LB_RAGEZAP3
  and boss.health > 3
  local chance = {1, 2, 3, 4, 5, 6, 7, 8}
			chance = chance[P_RandomKey(#chance)+1]
		if chance == 1
		boss.state = S_LB_SZAPNUM1
		elseif chance == 2
		boss.state = S_LB_SZAPNUM2
		elseif chance == 3
		boss.state = S_LB_SSZAPNUM1
		elseif chance == 4
		boss.state = S_LB_SSZAPNUM2
		elseif chance == 5
		boss.state = S_LB_SSZAPNUM3
		elseif chance == 6
		boss.state = S_LB_SSZAPNUM4
		elseif chance == 7
		boss.state = S_LB_SSZAPNUM5
		elseif chance == 8
		boss.state = S_LB_SSZAPNUM6
		end
  end
  if boss.state == S_LB_RAGEZAP3
  and boss.health > 1
  and boss.health < 4
  local chance = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12}
			chance = chance[P_RandomKey(#chance)+1]
		if chance == 1
		boss.state = S_LB_TRIPLEZAPNUM1
		elseif chance == 2
		boss.state = S_LB_TRIPLEZAPNUM2
		elseif chance == 3
		boss.state = S_LB_TRIPLEZAPNUM3
		elseif chance == 4
		boss.state = S_LB_TRIPLEZAPNUM4
		elseif chance == 5
		boss.state = S_LB_SZAPNUM1
		elseif chance == 6
		boss.state = S_LB_SZAPNUM2
		elseif chance == 7
		boss.state = S_LB_SSZAPNUM1
		elseif chance == 8
		boss.state = S_LB_SSZAPNUM2
		elseif chance == 9
		boss.state = S_LB_SSZAPNUM3
		elseif chance == 10
		boss.state = S_LB_SSZAPNUM4
		elseif chance == 11
		boss.state = S_LB_SSZAPNUM5
		elseif chance == 12
		boss.state = S_LB_SSZAPNUM6
		end
  end
  if boss.state == S_LB_RAGEZAP3
  and boss.health == 1
  boss.state = S_LB_RAGE1
  end
  for player in players.iterate
  if player.exit == nil
  player.exit = 0
  end
  if (player.exiting)
  player.exit = $1 + 1
  else
  player.exit = 0
  end
  if player.exit == 1
  S_StartSound(nil, sfx_rumble)
  P_StartQuake(8*FRACUNIT, 350)
  end
  end
end, MT_EGGZAP)