freeslot(
	"MT_DIGGINGBOSS",
	"S_DIGGER_STND",
	"S_DIGGER_DIGGING",
	"S_DIGGER_UP",
	"S_DIGGER_DOWN",
	"S_DIGGER_DEATH",
	"MT_TINYDRILL",
	"S_TINYDRILL",
	"S_TINYDRILLUP",
	"SPR_TDRL",
	"SPR_TDRT",
	"SPR_MNU2"
) //Yes, you can freeslot stuff like this in Lua.
mobjinfo[MT_DIGGINGBOSS] = {
	doomednum = 2026,
	spawnstate = S_DIGGER_STND,
	spawnhealth = 8,
	attacksound = sfx_s3k82,
	seestate = S_DIGGER_DIGGING,
	painsound = sfx_dmpain,
	painstate = S_DIGGER_DOWN,
	deathstate = S_DIGGER_DEATH,
	deathsound =  sfx_cybdth,
	reactiontime = 8*TICRATE,
	activesound = sfx_mindig,
	speed = 10,
	radius = 24*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_BOSS|MF_SHOOTABLE|MF_SPECIAL
}
mobjinfo[MT_TINYDRILL] = {
	spawnstate = S_TINYDRILL,
	spawnhealth = 1000,
	seesound = sfx_s3k83,
	attacksound = sfx_s3k82,
	activesound = sfx_mindig,
	radius = 10*FRACUNIT,
	height = 17*FRACUNIT,
	speed = 13,
	flags = MF_PAIN|MF_SPECIAL
}

states[S_TINYDRILL] = {SPR_TDRT, A, 1, function(mo)
	mo.reactiontime = $ -1
	mo.flags = $&~(MF_SPECIAL|MF_PAIN)
	if not (mo.target and mo.target.valid)
	and not (mo.target.player and mo.target.player.valid)
		A_Look(mo, 1)
	else	
		mo.flags = $|MF_NOCLIPTHING
		//A_HomingChase(mo, mo.info.speed*FRACUNIT)
		A_Chase(mo, 3)
		mo.flags = $&~MF_NOCLIPTHING
		A_GhostMe(mo)
		if (P_AproxDistance(mo.target.x-mo.x, mo.target.y-mo.y) < mo.radius) or mo.reactiontime == 0
			mo.state = S_TINYDRILLUP
			mo.flags = $|MF_SPECIAL|MF_NOGRAVITY|MF_PAIN
			A_PlayAttackSound(mo)
			mo.momz = P_MobjFlip(mo)*8*FRACUNIT
		end
		if leveltime % 15 == 0
			A_PlayActiveSound(mo)
		end
	end
	if (mo.eflags & MFE_VERTICALFLIP)
		mo.z = mo.ceilingz-mo.height
	else
		mo.z = mo.floorz
	end
end, 0, 0, S_TINYDRILL}
states[S_TINYDRILLUP] = {SPR_TDRL, A|FF_ANIMATE, 35, nil, 7, 2, S_XPLD1}

addHook("MobjSpawn", function(mo)
	mo.scale = mo.scale*2
	mo.reactiontime = 4*TICRATE
end, MT_TINYDRILL)
addHook("MobjSpawn", function(mo)
	mo.scale = mo.scale*3/2
end, MT_DIGGINGBOSS)
states[S_DIGGER_STND] = {SPR_NULL, A, 1, A_Look, 1, 0, S_DIGGER_STND}
states[S_DIGGER_DIGGING] = {SPR_MNU2, Q, 1, function(mo)
	mo.flags = $&~(MF_SPECIAL|MF_SHOOTABLE)
	if not (mo.target)
		A_Look(mo, 1)
	else
		if mo.reactiontime
			mo.reactiontime = $-1
			mo.flags = $|MF_NOCLIPTHING
			A_Chase(mo, 3)
			mo.flags = $&~MF_NOCLIPTHING
			A_GhostMe(mo)
			if (P_AproxDistance(mo.target.x-mo.x, mo.target.y-mo.y) < mo.radius)
			--and (abs(mo.target.z - mo.z) < mo.height)
				mo.state = S_DIGGER_UP
				mo.reactiontime = mo.info.reactiontime
				A_PlayAttackSound(mo)
				mo.momz = P_MobjFlip(mo)*10*FRACUNIT
				mo.flags = $|(MF_SPECIAL|MF_SHOOTABLE)				
			end
		else
			mo.state = S_DIGGER_UP
			mo.reactiontime = mo.info.reactiontime
			A_PlayAttackSound(mo)
			mo.flags = $|(MF_SPECIAL|MF_SHOOTABLE)
			mo.momz = P_MobjFlip(mo)*20*FRACUNIT
		end
		if leveltime % 15 == 0
			A_PlayActiveSound(mo)
		end
	end
	if (mo.eflags & MFE_VERTICALFLIP)
		mo.z = mo.ceilingz-mo.height
	else
		mo.z = mo.floorz
	end
end, 0, 0, S_DIGGER_DIGGING}		
states[S_DIGGER_UP] = {SPR_MNU2, A|FF_ANIMATE, -1, nil, 7, 1, S_DIGGER_DOWN}
states[S_DIGGER_DOWN] = {SPR_MNU2, I|FF_ANIMATE, -1, nil, 7, 1, S_DIGGER_DIGGING}
states[S_DIGGER_DEATH] = {SPR_MNU2, R, 4*TICRATE, nil, 0, 0, S_XPLD1}

addHook("MobjDamage", function(mo)
	if (mo and mo.valid)
		if mo.health > 1
			A_Pain(mo)
			mo.health = $-1
			mo.flags2 = $|MF2_FRET
			mo.frettimer = TICRATE
			return true
		end
	end
end, MT_DIGGINGBOSS)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	if not (mo.frettimer)
		mo.frettimer = 0
	else
		mo.frettimer = $-1
		if mo.frettimer == 1
			mo.flags2 = $&~MF2_FRET
		end
	end
	if mo.state == S_DIGGER_UP	
		if (mo.eflags & MFE_VERTICALFLIP)
			if mo.z-mo.momz <= mo.floorz+mo.height
				A_FlipGravity(mo)
				//mo.state = S_DIGGER_DOWN
			end
		else
			if mo.z+mo.momz >= mo.ceilingz-mo.height
				A_FlipGravity(mo)
				//mo.state = S_DIGGER_DOWN
			end
	end
		if (P_MobjFlip(mo)*mo.momz < 0)
			mo.state = S_DIGGER_DOWN
		end
	end
	if mo.state == S_DIGGER_DOWN
		if P_IsObjectOnGround(mo)
			A_PlayAttackSound(mo)
			mo.state = S_DIGGER_DIGGING
			A_SplitShot(mo, 150, (-30<<16)+MT_TINYDRILL)
		end
	end
	if mo.state == S_DIGGER_DEATH
		if mo.tics%8==0
			A_BossScream(mo)
		end
		if mo.tics == 1
			A_BossDeath(mo)
		end
	end
end, MT_DIGGINGBOSS)
