-- Green Hill Zone Boss
freeslot("MT_GREENHILLBOSS", "S_GREENHILLBOSS", "S_GREENHILLBOSSPAIN", "S_GREENHILLBOSSDIE", "S_GREENHILLBOSSFLEE", "SPR_GHZB")

mobjinfo[MT_GREENHILLBOSS] = {
doomednum = 210,
spawnstate = S_GREENHILLBOSS,
seestate = S_GREENHILLBOSS,
seesound = sfx_None,
attacksound = sfx_None,
painstate = S_GREENHILLBOSSPAIN,
painsound = sfx_dmpain,
deathstate = S_EGGMOBILE_DIE1,
xdeathstate = S_EGGMOBILE_FLEE1,
deathsound = sfx_cybdth,
spawnhealth = 8,
reactiontime = 256,
speed = 1*FRACUNIT,
radius = 24*FRACUNIT,
height = 76*FRACUNIT,
mass = sfx_None,
damage = 8*FRACUNIT,
flags = MF_SPECIAL|MF_SHOOTABLE|MF_FLOAT|MF_NOGRAVITY|MF_BOSS
}

states[S_GREENHILLBOSS] = {SPR_EGGM, A, 1, nil, 0, 0, S_GREENHILLBOSS}
states[S_GREENHILLBOSSPAIN] = {SPR_EGGM, V, 35, A_Pain, 0, 0, S_GREENHILLBOSS}

--Wrecking Ball
freeslot("MT_GREENHILLBOSSBALL", "S_GREENHILLBOSSBALL1", "S_GREENHILLBOSSBALL2", "S_GREENHILLBOSSBALLDIE", "SPR_GHZB")

mobjinfo[MT_GREENHILLBOSSBALL] = {
spawnstate = S_GREENHILLBOSSBALL1,
speed = 32,
deathsound = sfx_cybdth,
radius = 48*FRACUNIT,
height = 96*FRACUNIT,
flags = MF_PAIN|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_GREENHILLBOSSBALL1] = {SPR_GHZB, A, 1, nil, 0, 0, S_GREENHILLBOSSBALL2}
states[S_GREENHILLBOSSBALL2] = {SPR_GHZB, B, 1, nil, 0, 0, S_GREENHILLBOSSBALL1}
states[S_GREENHILLBOSSBALLDIE] = {SPR_NULL, A, 1, A_BossScream, 0, 0, S_NULL}

--Wrecking Ball Chain
freeslot("MT_GREENHILLBOSSCHAIN", "S_GREENHILLBOSSCHAIN", "S_GREENHILLBOSSCHAINDIE")

mobjinfo[MT_GREENHILLBOSSCHAIN] = {
spawnstate = S_GREENHILLBOSSCHAIN,
deathsound = sfx_cybdth,
radius = 48*FRACUNIT,
height = 96*FRACUNIT,
flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_GREENHILLBOSSCHAIN] = {SPR_BMCH, A, 1, nil, 0, 0, S_GREENHILLBOSSCHAIN}
states[S_GREENHILLBOSSCHAINDIE] = {SPR_NULL, A, 1, A_BossScream, 0, 0, S_NULL}

-- Lua code below

local function ball(ballmo)
	local bossmo = ballmo.target
	local verticalAngle = R_PointToAngle2(FixedHypot(ballmo.x,ballmo.y),ballmo.z,FixedHypot(bossmo.x,bossmo.y),bossmo.z)

	ballmo.angleAccel = ballmo.info.speed*-cos(ballmo.verticalAngle)/2
	ballmo.angleVelocity = $1 + ballmo.angleAccel
	ballmo.verticalAngle = $1 + ballmo.angleVelocity

	local x = bossmo.x + bossmo.info.reactiontime*cos(ballmo.verticalAngle)/FRACUNIT*cos(bossmo.angle)
	local y = bossmo.y + bossmo.info.reactiontime*cos(ballmo.verticalAngle)/FRACUNIT*sin(bossmo.angle)
	local z = bossmo.z + sin(ballmo.verticalAngle)*bossmo.info.reactiontime
	
	P_TeleportMove(ballmo, x, y, z)
	
	for i = 1, 4, 1
		if ballmo.chain[i].valid
			P_TeleportMove(ballmo.chain[i],(ballmo.x-bossmo.x)*i/5+bossmo.x,(ballmo.y-bossmo.y)*i/5+bossmo.y,(ballmo.z+(24*FRACUNIT)-bossmo.z)*i/5+bossmo.z)
		end
	end
	
end

local function boss(bossmo)
	if bossmo.ballSpawned == nil
		local ballmo = P_SpawnMobj(bossmo.x, bossmo.y, bossmo.z-bossmo.info.reactiontime, MT_GREENHILLBOSSBALL)
		local chain1mo = P_SpawnMobj(bossmo.x, bossmo.y, bossmo.z-bossmo.info.reactiontime/5, MT_GREENHILLBOSSCHAIN)
		local chain2mo = P_SpawnMobj(bossmo.x, bossmo.y, bossmo.z-bossmo.info.reactiontime*2/5, MT_GREENHILLBOSSCHAIN)
		local chain3mo = P_SpawnMobj(bossmo.x, bossmo.y, bossmo.z-bossmo.info.reactiontime*3/5, MT_GREENHILLBOSSCHAIN)
		local chain4mo = P_SpawnMobj(bossmo.x, bossmo.y, bossmo.z-bossmo.info.reactiontime*4/5, MT_GREENHILLBOSSCHAIN)
		
		ballmo.target = bossmo
		ballmo.chain = {chain1mo, chain2mo, chain3mo, chain4mo}
		bossmo.chain = {chain1mo, chain2mo, chain3mo, chain4mo}
		bossmo.tracer = ballmo
		ballmo.verticalAngle = ANGLE_180
		ballmo.angleVelocity = 0
		bossmo.ballSpawned = true
	end
	
	if bossmo.state == S_GREENHILLBOSS or bossmo.state == S_GREENHILLBOSSPAIN
		local axismo = P_GetClosestAxis(bossmo)
		
		if axismo != nil
			local x = axismo.x + axismo.spawnpoint.angle*cos(bossmo.angle-ANGLE_90)
			local y = axismo.y + axismo.spawnpoint.angle*sin(bossmo.angle-ANGLE_90)
			bossmo.angle = $1 + FixedAngle(bossmo.info.speed)
			P_TeleportMove(bossmo, x, y, bossmo.spawnpoint.z*FRACUNIT)
		else
			states[S_GREENHILLBOSS] = {SPR_EGGM, A, 1, A_HomingChase, bossmo.info.damage, 0, S_GREENHILLBOSS}
			if bossmo.z < bossmo.info.reactiontime*FRACUNIT+bossmo.floorz
				states[S_GREENHILLBOSS] = {SPR_EGGM, A, 1, nil, 0, 0, S_GREENHILLBOSS}
				bossmo.z = $1 + bossmo.info.damage
			end
		end
		
	end
	
	if bossmo.state == S_EGGMOBILE_DIE1 and bossmo.tracer != nil
		bossmo.tracer.state = S_GREENHILLBOSSBALLDIE
		for i=1, 4, 1
			bossmo.chain[i].state = S_GREENHILLBOSSCHAINDIE
		end
	end
	
--	local found = false
--	for mapthing in mapthings.iterate()
--		if mapthing == 753 --Zoom Tube Waypoint
--			if bossmo.nextWaypoint == nil
--				bossmo.nextWaypoint = 0+256*bossmo.info.angle
--			end
--			if mapthing.angle == bossmo.nextWaypoint
--				bossmo.target = mapthing.mobj
--				found = true
--			end
--		end
--	end
--	if not found
--		bossmo.nextWaypoint = 0+256*bossmo.info.angle
--	end
end

local function bossDead(bossmo)
	bossmo.state = bossmo.info.xdeathstate
end

addHook("MobjThinker", boss, MT_GREENHILLBOSS)
addHook("MobjThinker", ball, MT_GREENHILLBOSSBALL)
addHook("BossDeath",bossDead, MT_GREENHILLBOSS)